<?php
namespace Test\Test\Domain\Model;


/***************************************************************
 *
 *  Copyright notice
 *
 *  (c) 2016
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * Test1
 */
class Test1 extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity
{

    /**
     * title
     *
     * @var string
     */
    protected $title = '';
    
    /**
     * relations
     *
     * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Test\Test\Domain\Model\Relation>
     */
    protected $relations = null;
    
    /**
     * __construct
     */
    public function __construct()
    {
        //Do not remove the next line: It would break the functionality
        $this->initStorageObjects();
    }
    
    /**
     * Initializes all ObjectStorage properties
     * Do not modify this method!
     * It will be rewritten on each save in the extension builder
     * You may modify the constructor of this class instead
     *
     * @return void
     */
    protected function initStorageObjects()
    {
        $this->relations = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
    }
    
    /**
     * Returns the title
     *
     * @return string $title
     */
    public function getTitle()
    {
        return $this->title;
    }
    
    /**
     * Sets the title
     *
     * @param string $title
     * @return void
     */
    public function setTitle($title)
    {
        $this->title = $title;
    }
    
    /**
     * Adds a Relation
     *
     * @param \Test\Test\Domain\Model\Relation $relation
     * @return void
     */
    public function addRelation(\Test\Test\Domain\Model\Relation $relation)
    {
        $this->relations->attach($relation);
    }
    
    /**
     * Removes a Relation
     *
     * @param \Test\Test\Domain\Model\Relation $relationToRemove The Relation to be removed
     * @return void
     */
    public function removeRelation(\Test\Test\Domain\Model\Relation $relationToRemove)
    {
        $this->relations->detach($relationToRemove);
    }
    
    /**
     * Returns the relations
     *
     * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Test\Test\Domain\Model\Relation> $relations
     */
    public function getRelations()
    {
        return $this->relations;
    }
    
    /**
     * Sets the relations
     *
     * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Test\Test\Domain\Model\Relation> $relations
     * @return void
     */
    public function setRelations(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $relations)
    {
        $this->relations = $relations;
    }

}