<?php

namespace Test\Test\Tests\Unit\Domain\Model;

/***************************************************************
 *  Copyright notice
 *
 *  (c) 2016 
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * Test case for class \Test\Test\Domain\Model\Test1.
 *
 * @copyright Copyright belongs to the respective authors
 * @license http://www.gnu.org/licenses/gpl.html GNU General Public License, version 3 or later
 *
 */
class Test1Test extends \TYPO3\CMS\Core\Tests\UnitTestCase
{
	/**
	 * @var \Test\Test\Domain\Model\Test1
	 */
	protected $subject = NULL;

	public function setUp()
	{
		$this->subject = new \Test\Test\Domain\Model\Test1();
	}

	public function tearDown()
	{
		unset($this->subject);
	}

	/**
	 * @test
	 */
	public function getTitleReturnsInitialValueForString()
	{
		$this->assertSame(
			'',
			$this->subject->getTitle()
		);
	}

	/**
	 * @test
	 */
	public function setTitleForStringSetsTitle()
	{
		$this->subject->setTitle('Conceived at T3CON10');

		$this->assertAttributeEquals(
			'Conceived at T3CON10',
			'title',
			$this->subject
		);
	}

	/**
	 * @test
	 */
	public function getRelationsReturnsInitialValueForRelation()
	{
		$newObjectStorage = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
		$this->assertEquals(
			$newObjectStorage,
			$this->subject->getRelations()
		);
	}

	/**
	 * @test
	 */
	public function setRelationsForObjectStorageContainingRelationSetsRelations()
	{
		$relation = new \Test\Test\Domain\Model\Relation();
		$objectStorageHoldingExactlyOneRelations = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
		$objectStorageHoldingExactlyOneRelations->attach($relation);
		$this->subject->setRelations($objectStorageHoldingExactlyOneRelations);

		$this->assertAttributeEquals(
			$objectStorageHoldingExactlyOneRelations,
			'relations',
			$this->subject
		);
	}

	/**
	 * @test
	 */
	public function addRelationToObjectStorageHoldingRelations()
	{
		$relation = new \Test\Test\Domain\Model\Relation();
		$relationsObjectStorageMock = $this->getMock('TYPO3\\CMS\\Extbase\\Persistence\\ObjectStorage', array('attach'), array(), '', FALSE);
		$relationsObjectStorageMock->expects($this->once())->method('attach')->with($this->equalTo($relation));
		$this->inject($this->subject, 'relations', $relationsObjectStorageMock);

		$this->subject->addRelation($relation);
	}

	/**
	 * @test
	 */
	public function removeRelationFromObjectStorageHoldingRelations()
	{
		$relation = new \Test\Test\Domain\Model\Relation();
		$relationsObjectStorageMock = $this->getMock('TYPO3\\CMS\\Extbase\\Persistence\\ObjectStorage', array('detach'), array(), '', FALSE);
		$relationsObjectStorageMock->expects($this->once())->method('detach')->with($this->equalTo($relation));
		$this->inject($this->subject, 'relations', $relationsObjectStorageMock);

		$this->subject->removeRelation($relation);

	}
}
